package com.steerinfo.baseinfo.meterbasematterinfodirect.controller;

import com.steerinfo.baseinfo.meterbaseunitdirect.model.MeterBaseUnitDirect;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.user.UserPayload;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.baseinfo.meterbasematterinfodirect.model.MeterBaseMatterInfoDirect;
import com.steerinfo.baseinfo.meterbasematterinfodirect.service.IMeterBaseMatterInfoDirectService;
import com.steerinfo.meterwork.except.MarkerMetException;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;
import org.springframework.web.bind.annotation.*;

import java.util.*;
import java.math.BigDecimal;

/**
 * MeterBaseMatterInfoDirect RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-02-11 06:04
 * 类描述
 * 修订历史：
 * 日期：2022-02-11
 * 作者：generator
 * 参考：
 * 描述：MeterBaseMatterInfoDirect RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterbasematterinfodirects")
@Api(value = "/${api.version}/meterbasematterinfodirects", tags = "计量物料配置直接录入 - BaseRESTfulController")
public class MeterBaseMatterInfoDirectController extends BaseRESTfulController {

    @Autowired
    IMeterBaseMatterInfoDirectService meterBaseMatterInfoDirectService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasematterinfodirect:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseMatterInfoDirect> list = meterBaseMatterInfoDirectService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasematterinfodirect:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseMatterInfoDirect> list = meterBaseMatterInfoDirectService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MeterBaseMatterInfoDirect对象创建")
    @ApiImplicitParam(name = "meterBaseMatterInfoDirect", value = "详细实体meterBaseMatterInfoDirect", required = true, dataType = "MeterBaseMatterInfoDirect")
    //@RequiresPermissions("meterbasematterinfodirect:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody MeterBaseMatterInfoDirect model){
        try{
            String msg = meterBaseMatterInfoDirectService.checkandadd(model);
            if(msg != null && !msg.equals("")){
                return failed(null,msg);
            }
        }catch (Exception e){
            e.printStackTrace();
            return failed(null, "操作异常，请确认！");
        }

        return success();
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasematterinfodirect:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterBaseMatterInfoDirect meterBaseMatterInfoDirect = meterBaseMatterInfoDirectService.getById(id);
        return success(meterBaseMatterInfoDirect);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterBaseMatterInfoDirect信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterBaseMatterInfoDirect", value = "详细实体meterBaseMatterInfoDirect", required = true, dataType = "MeterBaseMatterInfoDirect")
    })
    //@RequiresPermissions("meterbasematterinfodirect:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseMatterInfoDirect model){
        try{
            String msg = meterBaseMatterInfoDirectService.checkandupdate(id,model);
            if (msg != null && !msg.equals("")) {
                return failed(null,msg);
            }
        }
        catch (Exception e){
            e.printStackTrace();
            return failed(null,"操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasematterinfodirect:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterBaseMatterInfoDirectService.delete(ids);
    	}
      return success();
    }
    @ApiOperation(value = "批量删除", notes = "根据MeterBaseUnitDirect对象批量删除")
    @ApiImplicitParam(paramType = "path",  required = true, dataType = "List<MeterBaseUnitDirect>")
    @Transactional
    @PutMapping(value = "/batchdelete")//String
    public RESTfulResult batchsdelete(@RequestBody List<MeterBaseMatterInfoDirect> models) {
        try {
            UserPayload payload = UserPayload.getCurrUser();
            String userId = payload.getUserCode();
            String userName = payload.getUserName();
            for (MeterBaseMatterInfoDirect model : models){
                model.setDeleteManNo(userId);
                model.setDeleteManName(userName);
                model.setDeleteTime(new Date());
                model.setValidFlag("0");
            }
            meterBaseMatterInfoDirectService.batchUpdate(models);
            return success();
        } catch (Exception ex) {
            ex.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }
}
